package w1;

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 *
 * @author mm
 */
public class Vector2D {

    private double x, y;

    public Vector2D() {
        this(0, 0);
    }

    public Vector2D(double x, double y) {
        this.x = x;
        this.y = y;
    }
    
    public Vector2D(double fromX, double fromY, double toX, double toY) {
        x = toX - fromX;
        y = toY - fromY;
    }

    public double getX() {
        return x;
    }

    public double getY() {
        return y;
    }
    
    public double magnitude() {
        return Math.sqrt(x * x + y * y);
    }

    public Vector2D normalize() {
        double mag = Math.sqrt(x * x + y * y);
        return new Vector2D(x / mag, y / mag);
    }
    
    public Vector2D add(Vector2D v) {
        return add(v.getX(), v.getY());
    }
    
    public Vector2D add(double x, double y) {
        return new Vector2D(this.x + x, this.y + y);
    }

    public Vector2D scale(double alpha) {
        return new Vector2D(alpha * x, alpha * y);
    }
}